This adapts [Black Magic firmware](https://github.com/blacksphere/blackmagic), originally for the [Black Magic Probe](https://github.com/blacksphere/blackmagic/wiki), for the [BusVoodoo multi-protocol debugging adapter](https://bus.cuvoodoo.info/).

connector
=========

Black Magic for BusVoodoo pinout:

              -----
          GND |1 2| 5V
          3V3 |3 4| SRST
      UART RX  5 6| UART TX
JTDO/TRACESWO |7 8| JTDI
   JTMS/SWDIO |910| JTCK/SWCLK
              -----

The pinout will also be displayed on the OLED screen when present.

The 5V and 3V3 power outputs are software switchable.
To enable powering the target board, run the `monitor tpwr enable` command in GDB.

To pulse SRST low, to cause a system reset of the target, run `monitor connect_srst enable` followed by `monitor hard_srst` in GDB.

flashing
========

Flashing firmwares can be done using the [BusVoodoo DFU bootloader](https://bus.cuvoodoo.info/manual/index.html#_usb_dfu) already present on the BusVoodoo.

To install the Black Magic firmware, run the following command:
`sudo dfu-util -d 1209:4256 -D blackmagic.bin`

To re-install or update the Black Magic firmware, run the following command:
`sudo dfu-util -d 1d50:6018,1209:4256 -D blackmagic.bin`

To re-install the BusVoodoo application firmware, run the following command:
`sudo dfu-util -d 1d50:6018,1209:4256 -D application.bin`

**Warning:** Do not replace the BusVoodoo DFU bootloader with the Black Magic DFU bootloader since this can't properly flash firmwares.
The reasons could be the 2kB flash pages of the BusVoodoo STM32F103RC micro-controller.

source
======

The source code can be found [here](https://bus.cuvoodoo.info/files/mimic/blackmagic-src.zip).
To build it, run the following command:

  cd blackmagic-src
  make
  cd src
  make clean
  make PROBE_HOST=busvoodoo

